	TITLE	ETHEREAL-15

	COLOR EQU 70h

CODE	SEGMENT
	ASSUME	CS:CODE,DS:CODE

	ORG	100h

START:	MOV	DX,OFFSET TEXT
	MOV	AH,9
	INT	21h
	MOV	CX,0B000h
	MOV	AH,0Fh
	INT	10h
	MOV	BL,AH
	CMP	AL,7
	JE	MONO
	MOV	CH,0B8h
MONO:	MOV	ES,CX
	MOV	AH,3
	INT	10h
	PUSH	DX
	MOV	AL,BL
	MUL	DH
	MOV	DH,0
	ADD	AX,DX
	SHL	AX,1
	XCHG	SI,AX
	CLD
	CALL	PRDATE
	MOV	DI,SI
	POP	DX
	MOV	CL,DL
	MOV	CH,DL
	ADD	CH,7
	JMP	SHORT INKEY
DIGIT:	STOSB
	DEC	DI
	PUSH	CX
	PUSH	DX
	CALL	RDDATE
	POP	DX
	POP	CX
	CALL	PRDAY
RIGHT:	MOV	AL,1
	CMP	DL,CH
LEFT:	JE	INKEY
MOVE:	CBW
	ADD	DL,AL
	ADD	DI,AX
	ADD	DI,AX
	MOV	BL,DL
	SUB	BL,CL
	MOV	AH,2
	CMP	BL,AH
	JE	MOVE
	CMP	BL,5
	JE	MOVE
	INT	10h
INKEY:	MOV	AH,0
	INT	16h
	CMP	AL,'9'
	JA	INKEY
	CMP	AL,'0'
	JAE	DIGIT
	CMP	AL,' '
	JE	SPACE
	CMP	AL,8
	JE	BS
	TEST	AL,AL
	JNZ	STILL
	CMP	AH,4Dh
	JE	RIGHT
	CMP	AH,4Bh
	JNE	INKEY
BS:	MOV	AL,-1
	CMP	DL,CL
	JMP	LEFT
SPACE:	PUSH	CX
	PUSH	DX
	PUSH	DI
	CALL	RDDATE
	INC	DAY
	MOV	BL,DH
	MOV	BH,0
	CMP	DL,DAYS-1[BX]
	JB	INCEND_
	CMP	DL,28
	JNE	NOFEB
	TEST	CL,00000011B
	JZ	INCEND_
NOFEB:	MOV	AL,1
	MOV	DAY,AL
	INC	BX
	XCHG	AX,BX
	CMP	AL,13
	JB	INCEND
	XCHG	AX,BX
	INC	YEAR
	CMP	CL,LOW(2099)
	JNE	INCEND
	AND	YEAR,AL
INCEND:	MOV	MONTH,AL
INCEND_:CALL	PRDATE		; AL <- '0'..'9'
	POP	DI
	POP	DX
	POP	CX
;;;	JMP	INKEY
STILL:	CMP	AL,1Bh
	JE	ESCAPE
	CMP	AL,0Dh
	JNE	INKEY
	CMP	BYTE PTR ES:1Ch[SI],'?'
	JE	INKEY
	PUSH	ES
	POP	DS
	PUSH	CS
	POP	ES
	MOV	DI,OFFSET FILE
	MOV	DX,DI
	MOVSB
	INC	SI
	MOVSB
	LODSW
	INC	SI
	MOVSB
	INC	SI
	MOVSB
	CMPSW
	INC	SI
	MOVSB
	INC	SI
	MOVSB
	PUSH	CS
	POP	DS
	MOV	AX,WORD PTR MONTH
	ADD	AH,20
	MOV	CL,5
	SHL	AL,CL
	RCL	AH,1
	OR	AL,DAY
	MOV	BX,AX
	MOV	DI,OFFSET DUMP+918H
	CALL	PUT_HEX
	SCASW				; MOV	DI,OFFSET DUMP+091CH
	MOV	AL,BH
	CALL	PUT_HEX
	SCASW				; MOV	DI,OFFSET DUMP+0920H
	MOV	AL,0CBH			; CRC
	SUB	AL,BL
	SUB	AL,BH
	CALL	PUT_HEX
	XOR	CX,CX
	MOV	AH,3Ch
	INT	21h
	JC	IOERR
	XCHG	BX,AX
	MOV	DL,LOW(OFFSET DUMP)
	MOV	CX,6126
	MOV	AH,40h
	INT	21h
	JC	IOERR
	CMP	CX,AX
	JNE	IOERR

ESCAPE:	MOV	DX,OFFSET CRLF
WRITE:	MOV	AH,9
	INT	21h
	MOV	AH,4Ch
	INT	21h
IOERR:	MOV	DL,LOW(OFFSET ERRMESS)
	JMP	WRITE

PUT_HEX	PROC	NEAR
	DB	0D4H,10H
	CALL	HEX
HEX:	XCHG	AL,AH
	CMP	AL,10
	SBB	AL,69H
	DAS
	STOSB
	RET
PUT_HEX	ENDP

PRDAY	PROC	NEAR
	PUSH	CX
	PUSH	DX
	PUSH	SI
	PUSH	DI
	MOV	AH,2Ah
	INT	21h
	PUSH	CX
	PUSH	DX
	MOV	DX,WORD PTR DAY
	MOV	AX,WORD PTR YEAR
	CALL	ADD_XX
	MOV	AH,2Bh
	INT	21h
	TEST	AL,AL
	JS	BADDT
	MOV	AH,2Ah
	INT	21h
BADDT:	POP	DX
	POP	CX
	PUSH	AX
	MOV	AH,2Bh
	INT	21h
	POP	AX
	LEA	DI,18[SI]
	MOV	CX,MONDAY-SUNDAY
	IMUL	CL
	ADD	AX,OFFSET SUNDAY
	XCHG	SI,AX
	MOV	AH,COLOR
STRING:	LODSB
	STOSW
	LOOP	STRING
	POP	DI
	POP	SI
	POP	DX
	POP	CX
	RET
PRDAY	ENDP

PRDATE	PROC	NEAR
	CALL	PRDAY
	MOV	DI,SI
	PUSH	SI
	MOV	SI,OFFSET DAY
	CALL	PRINT
	CALL	PNPRIN
	CALL	PNPRIN
	POP	SI
	RET

PNPRIN:	MOV	AL,'.'
	STOSW
PRINT:	LODSB
	AAM
	ADD	AX,'00'
	XCHG	AL,AH
	STOSB
	MOV	AL,COLOR
	STOSB
	XCHG	AL,AH
	STOSW
	RET
PRDATE	ENDP

RDDATE	PROC	NEAR
	PUSH	SI
	CALL	READ
	XCHG	DX,AX
	CALL	READ
	MOV	DH,AL
	MOV	WORD PTR DAY,DX
	CALL	READ
	MOV	YEAR,AL
	POP	SI
	CBW
ADD_XX:	ADD	AX,2000
	XCHG	CX,AX
	RET
RDDATE	ENDP

READ	PROC	NEAR
	LODS	WORD PTR ES:[SI]
	MOV	AH,AL
	LODS	BYTE PTR ES:[SI]
	SUB	AX,'00'
	AAD
	ADD	SI,3
	RET
READ	ENDP

TEXT	DB	0Dh,0Ah
	DB	'Ethereal-15 commercial generator',0Dh,0Ah
	DB	'Last date : $'
ERRMESS	DB	0Dh,0Ah,'I/O Error'
CRLF	DB	0Dh,0Ah,'$'
	DB	4,4,4,' ??? ',4,4,4
SUNDAY	DB	'ᥭ'
MONDAY	DB	'쭨'
	DB	4,' ୨ ',4
	DB	4,4,' । ',4,4
	DB	4,' ⢥ ',4
	DB	4,' ⭨ ',4
	DB	4,' 㡡 ',4
DAYS	DB	31,28,31,30,31,30,31,31,30,31,30,31
DAY	DB	1
MONTH	DB	1
YEAR	DB	0
FILE	DB	0,?,?,?,'20',?,?,'.HEX',0
DUMP:

CODE	ENDS

	END	START
